unit UIsotrackII;

interface

type


    TPonto3D = class
      x, y, z: real;
    end;

// --- Estrutura de dados usada para guardar informaoes do  ratreador

    TDataIT = class
      Pitch,Roll,Yaw: Double;
      Pos: TPonto3D;
    end;

     function  InitIT (nport:integer;brate:integer;mode:boolean;Units:boolean):string;
     procedure ReadIT (var Mao, Cabeca: TDataIT);
     function  EndIT	:string;
     procedure WriteIT (str:string);
     function  Dataformat(str:string;var i:integer):string;
     procedure Alignment (x0:string;y0:string;z0:string;xx:string;xy:string;xz:string;yx:string;yy:string;yz:string);
     procedure ResetAlignment;
     procedure Increment (str:string);
     procedure Requisita;
     function  Verif(str: string; i: integer):boolean;
     function  verifdata(str: string):boolean;

implementation

uses
    SysUtils, uSimpleSerial;

var
   SerialPort: TSimpleSerial;

//************************************************************************
//
//
//************************************************************************

function InitIT(nport:integer;brate:integer; mode:boolean; Units:boolean):string;
begin
  SerialPort := TSimpleSerial.Create(nport,brate);
  SerialPort.SerialClear;
  if mode then
    SerialPort.SerialWrite('C')     // --- Modo Contnuo
  else
     SerialPort.SerialWrite('c');   // --- Modo no contnuo
  if Units then
    SerialPort.SerialWrite('U')     // --- Unidade de medida (????)
  else
     SerialPort.SerialWrite('u');		// --- Unidade de medida (????)
end;

//************************************************************************
//
//
//************************************************************************

function EndIT:string;
begin
  //serialPort.SerialWrite('^S');
  serialport.SerialClear;
  SerialPort.Free;

end;

//************************************************************************
//
//
//************************************************************************

procedure ReadIT (var Mao, Cabeca: TDataIT);
var
 i,g: integer;
 m,Buffer, Initstr: string;
 TmpM, TmpC: TDataIT;

begin

  TmpM:= TDataIT.Create;
  TmpM.Pos:= TPonto3D.Create;
  TmpC:= TDataIT.Create;
  TmpC.Pos:= TPonto3D.Create;

  i:=1;
  Buffer := SerialPort.SerialRead;

  // --- Se no leu bytes suficientes para...
  // ... dois pacotes entao cai fora.
  if (Length(Buffer)<(150)) then exit;

  Initstr:=copy(buffer,i,3);
  if (Initstr<>'01 ') then 	// --- Se nao estiver no inicio do pacote do...
  begin                    	// ... do rastreador 1 ou do 2...
   if (Initstr<>'02 ') then
   begin
      repeat
        Initstr:=copy(buffer,i,1);	// ... entao vai at o inicio do...
        i:=i+1;											// ... proximo pacote
      until (Initstr=chr(10));
      initstr:=copy(buffer,i,3);
   end;
  end;

  if Initstr= '01 ' then		// --- Se primeiro pacote for do rastreador 1
  begin
   i:=i+3;		// --- Pula o cabecalho
   if (Verif(buffer,i)) then exit;         // --- Se for um dado aparentemente valido...
   try
   m:=dataformat(buffer,i);
   if verifdata(m) then
   TmpM.Pos.Z:=-strtofloat(m)// ... entao le e coloca num temporario.
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

   if (Verif(buffer,i)) then exit;
   try
   m:=dataformat(buffer,i);
   if verifdata(m) then
   TmpM.Pos.X:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

   if (Verif(buffer,i)) then exit;
   try
   m:=dataformat(buffer,i);
   if verifdata(m) then
   TmpM.Pos.Y:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

   if (Verif(buffer,i)) then exit;
   try
   m:=dataformat(buffer,i);
   if verifdata(m) then
   TmpM.Yaw:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

   if (Verif(buffer,i)) then exit;
   try
   m:=dataformat(buffer,i);
   if verifdata(m) then
   TmpM.Pitch:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

   if (Verif(buffer,i)) then exit;
   try
   m:=dataformat(buffer,i);
   if verifdata(m) then

   TmpM.Roll:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;


   // --- Se chegou ate aqui entao os dados lidos sao validos e...
   // ... podem ser utilizados.
   if (Mao<>nil) then
   begin
     Mao.Pos.Free;
     Mao.Free;
   end;

   Mao:= TmpM;

   i:=i+2;	// --- Pula <cr> <lf>
   Initstr:=copy(buffer,i,3);
   if (initstr='02 ') then
   begin
     i:=i+3;  // --- Pula o cabecalho do pacote do rastreador 2

     g:= length(buffer);
     if (g-i)<70 then exit;	// --- Se nao exitem bytes suficientes para um pacote...
   												// ... inteiro entao cai fora.

     if (Verif(buffer,i)) then exit;
     try
     m:=dataformat(buffer,i);
     if verifdata(m) then

     TmpC.Pos.Z:=-strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

     if (Verif(buffer,i)) then exit;
     try
   m:=dataformat(buffer,i);
   if verifdata(m) then

     TmpC.Pos.X:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

     if (Verif(buffer,i)) then exit;
     try
   m:=dataformat(buffer,i);
   if verifdata(m) then

     TmpC.Pos.Y:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

     if (Verif(buffer,i)) then exit;
     try
   m:=dataformat(buffer,i);
   if verifdata(m) then

     TmpC.Yaw:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

     if (Verif(buffer,i)) then exit;
     try
   m:=dataformat(buffer,i);
   if verifdata(m) then

     TmpC.Pitch:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

     if (Verif(buffer,i)) then exit;
     try
   m:=dataformat(buffer,i);
   if verifdata(m) then

     TmpC.Roll:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

     if (Cabeca<>nil) then
     begin
   	   Cabeca.Pos.Free;
       Cabeca.Free;
     end;

     Cabeca:= TmpC;
     exit;
   end;
  end

else  if initstr= '02 ' then	// --- Idem ao anterior so que agora comeca...
	begin												// ... lendo o pacote do rastreador 2 e depois...
   i:=i+3;										// ... o do rastreador 1.
   if (Verif(buffer,i)) then exit;
   try
   m:=dataformat(buffer,i);
   if verifdata(m) then

   TmpC.Pos.Z:=-strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

   if (Verif(buffer,i)) then exit;
   try
   m:=dataformat(buffer,i);
   if verifdata(m) then

   TmpC.Pos.X:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

   if (Verif(buffer,i)) then exit;
   try
   m:=dataformat(buffer,i);
   if verifdata(m) then

   TmpC.Pos.Y:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;


   if (Verif(buffer,i)) then exit;
   try
   m:=dataformat(buffer,i);
   if verifdata(m) then

   TmpC.Yaw:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

   if (Verif(buffer,i)) then exit;
   try
   m:=dataformat(buffer,i);
   if verifdata(m) then

   TmpC.Pitch:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

   if (Verif(buffer,i)) then exit;
   try
   m:=dataformat(buffer,i);
   if verifdata(m) then

   TmpC.Roll:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

   if (Cabeca<>nil) then
   begin
   	 Cabeca.Pos.Free;
     Cabeca.Free;
   end;

   Cabeca:= TmpC;

   i:=i+2;	// --- Pula <cr> <lf>
   Initstr:=copy(buffer,i,3);
   if (initstr='01 ') then
   begin
     i:=i+3;  // --- Pula o cabecalho do pacote do rastreador 1

     g:= length(buffer);
     if (g-i)<70 then exit;

     if (Verif(buffer,i)) then exit;
     try
   m:=dataformat(buffer,i);
   if verifdata(m) then

     TmpM.Pos.Z:=-strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

     if (Verif(buffer,i)) then exit;
     try
   m:=dataformat(buffer,i);
   if verifdata(m) then

     TmpM.Pos.X:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;

     if (Verif(buffer,i)) then exit;
     try
   m:=dataformat(buffer,i);
   if verifdata(m) then

     TmpM.Pos.Y:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;


     if (Verif(buffer,i)) then exit;
     try
   m:=dataformat(buffer,i);
   if verifdata(m) then
     TmpM.Yaw:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;


     if (Verif(buffer,i)) then exit;
     try
   m:=dataformat(buffer,i);
   if verifdata(m) then
     TmpM.Pitch:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;


     if (Verif(buffer,i)) then exit;
     try
   m:=dataformat(buffer,i);
   if verifdata(m) then
     TmpM.Roll:=strtofloat(m)
   else exit;
     except
      on EConvertError do
      begin
        exit;
      end;
     end;


     if (Mao<>nil) then
     begin
   	   Mao.Pos.Free;
       Mao.Free;
     end;

     Mao:= TmpM;
	 end;
  end;
end;

//************************************************************************
//
//
//************************************************************************

procedure WriteIT(str :string);
begin
   serialport.SerialWrite(str);
end;

//************************************************************************
//
//
//************************************************************************

function DataFormat(str:string;var i:integer):string;
var
   s:string;
//   ncd:integer; //numero de casa decimais apos o ponto
begin
i:=i-1;
//ncd:=-1;
s:='';
     repeat
     i:=i+1;
     until str[i]<>chr(32);
     repeat
        if str[i]='.' then
        begin
          s:=s+',';
//          ncd:=ncd+1;
        end
        else begin
//          if ncd<>-1 then
//            ncd:=ncd+1;
          s:=s+copy(str,i,1);
        end;
        i:=i+1;
     until (str[i]=chr(32)) or (str[i]=chr(13)) or (str[i]='-');// or (ncd=2);
     dataformat:=s;
end;

//************************************************************************
//
//
//************************************************************************

procedure Alignment(x0:string;y0:string;z0:string;xx:string;xy:string;xz:string;yx:string;yy:string;yz:string);
begin
     serialport.SerialWrite('A1,'+x0+','+y0+','+z0+','+xx+','+xy+','+xz+','+yx+','+yy+','+yz+chr(13));
end;

//************************************************************************
//
//
//************************************************************************

procedure ResetAlignment;
begin
serialport.SerialWrite('R1'+chr(13));
end;

//************************************************************************
//
//
//************************************************************************

procedure Increment(str:string);
begin
  serialport.SerialWrite('I'+str+chr(13));
end;

//************************************************************************
//
//
//************************************************************************

procedure Requisita;
begin
  serialport.SerialWrite('P');
end;

//************************************************************************
//
//
//************************************************************************

function verif (str:string; i:integer):boolean;
var t:string;
begin
  verif:=false;
  t:=copy(str,i,1);
  if t=chr(13)
  then verif:=true;
end;


function  verifdata(str: string):boolean;
var
 i:integer;
begin
    if (str[1]='-') or ((str[1]>='0') and (str[1]<='9')) then
    begin
      i:=2;
      while (str[i]<>',') do
      begin
        if (str[i]<'0') or (str[i]>'9') then
        begin
          result:= false;
          exit;
        end;
        inc(i);
      end;
      inc(i);
      while (i<length(str)) do
      begin
        if (str[i]<'0') or (str[i]>'9') then
        begin
          result:=false;
          exit;
        end;
        inc(i);
      end;
    end;
    result:= true;
end;

end.
